--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -3534,67 +3333,33 @@
 	count = softs->container_count;
 	if (aac_get_container_count(softs, &count) == AACERR)
 		return (AACERR);
-
 	for (i = total = 0; i < count; i++) {
-		enum aac_cfg_event event = aac_probe_container(softs, i);
-		if ((event != AAC_CFG_NULL_NOEXIST) &&
-		    (event != AAC_CFG_NULL_EXIST)) {
-			(void) aac_handle_dr(softs, i, -1, event);
+		if (aac_probe_container(softs, i) == AACOK)
 			total++;
-		}
 	}
-
 	if (count < softs->container_count) {
 		struct aac_container *dvp;
 
 		for (dvp = &softs->containers[count];
 		    dvp < &softs->containers[softs->container_count]; dvp++) {
-			if (!AAC_DEV_IS_VALID(&dvp->dev))
+			if (dvp->dev.valid == 0)
 				continue;
 			AACDB_PRINT(softs, CE_NOTE, ">>> Container %d deleted",
 			    dvp->cid);
-			dvp->dev.flags &= ~AAC_DFLAG_VALID;
-			(void) aac_handle_dr(softs, dvp->cid, -1,
-			    AAC_CFG_DELETE);
+			dvp->dev.valid = 0;
+			(void) aac_dr_event(softs, dvp->cid, -1,
+			    AAC_DEV_OFFLINE);
 		}
 	}
-
 	softs->container_count = count;
-	AACDB_PRINT(softs, CE_CONT, "?Total %d container(s) found", total);
+	AACDB_PRINT(softs, CE_CONT, "Total %d container(s) found", total);
 	return (AACOK);
 }
 
 static int
-aac_probe_jbod(struct aac_softstate *softs, int tgt, int event)
-{
-	ASSERT(AAC_MAX_LD <= tgt);
-	ASSERT(tgt < AAC_MAX_DEV(softs));
-	struct aac_device *dvp;
-	dvp = AAC_DEV(softs, tgt);
-
-	switch (event) {
-	case AAC_CFG_ADD:
-		AACDB_PRINT(softs, CE_NOTE,
-		    ">>> Jbod %d added", tgt - AAC_MAX_LD);
-		dvp->flags |= AAC_DFLAG_VALID;
-		dvp->type = AAC_DEV_PD;
-		break;
-	case AAC_CFG_DELETE:
-		AACDB_PRINT(softs, CE_NOTE,
-		    ">>> Jbod %d deleted", tgt - AAC_MAX_LD);
-		dvp->flags &= ~AAC_DFLAG_VALID;
-		break;
-	default:
-		return (AACERR);
-	}
-	(void) aac_handle_dr(softs, tgt, 0, event);
-	return (AACOK);
-}
-
-static int
 aac_alloc_comm_space(struct aac_softstate *softs)
 {
-	size_t rlen;
+	size_t rlen, maxsize;
 	ddi_dma_cookie_t cookie;
 	uint_t cookien;
 
@@ -3609,10 +3374,15 @@
 		    "Cannot alloc dma handle for communication area");
 		goto error;
 	}
+
+	maxsize = sizeof(struct aac_comm_space);
+	if ((softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) ||
+		(softs->flags & AAC_FLAGS_NEW_COMM_TYPE2)) 
+		maxsize += (softs->aac_max_fibs-1) * sizeof(uint32_t);
 	if (ddi_dma_mem_alloc(
 	    softs->comm_space_dma_handle,
-	    sizeof (struct aac_comm_space),
-	    &softs->acc_attr,
+	    maxsize,
+	    &aac_acc_attr,
 	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT,
 	    DDI_DMA_SLEEP,
 	    NULL,
@@ -3627,7 +3397,7 @@
 	    softs->comm_space_dma_handle,
 	    NULL,
 	    (caddr_t)softs->comm_space,
-	    sizeof (struct aac_comm_space),
+	    maxsize,
 	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT,
 	    DDI_DMA_SLEEP,
 	    NULL,
@@ -3637,6 +3407,8 @@
 		    "DMA bind failed for communication area");
 		goto error;
 	}
+
+	bzero(softs->comm_space, maxsize);
 	softs->comm_space_phyaddr = cookie.dmac_address;
 
 	return (AACOK);
@@ -3655,7 +3427,6 @@
 static void
 aac_free_comm_space(struct aac_softstate *softs)
 {
-
 	(void) ddi_dma_unbind_handle(softs->comm_space_dma_handle);
 	ddi_dma_mem_free(&softs->comm_space_acc_handle);
 	softs->comm_space_acc_handle = NULL;
@@ -3679,25 +3450,41 @@
 
 	comm_space_phyaddr = softs->comm_space_phyaddr;
 
+	/* reset rrq index */
+	softs->aac_host_rrq_idx = 0;
+
 	/* Setup adapter init struct */
 	initp = &softs->comm_space->init_data;
-	bzero(initp, sizeof (struct aac_adapter_init));
 
 	ddi_put32(acc, &initp->InitStructRevision, AAC_INIT_STRUCT_REVISION);
 	ddi_put32(acc, &initp->HostElapsedSeconds, ddi_get_time());
+	ddi_put32(acc, &initp->MiniPortRevision,AAC_INIT_STRUCT_MINIPORT_REVISION);
 
 	/* Setup new/old comm. specific data */
-	if (softs->flags & AAC_FLAGS_RAW_IO) {
+	if (softs->flags & AAC_FLAGS_NEW_COMM) {
 		uint32_t init_flags = 0;
 
-		if (softs->flags & AAC_FLAGS_NEW_COMM)
-			init_flags |= AAC_INIT_FLAGS_NEW_COMM_SUPPORTED;
-		/* AAC_SUPPORTED_POWER_MANAGEMENT */
-		init_flags |= AAC_INIT_FLAGS_DRIVER_SUPPORTS_PM;
-		init_flags |= AAC_INIT_FLAGS_DRIVER_USES_UTC_TIME;
+		init_flags |= AAC_INIT_FLAGS_NEW_COMM_SUPPORTED;
+		if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) {
+			init_flags |= (AAC_INITFLAGS_NEW_COMM_TYPE1_SUPPORTED |
+				AAC_INITFLAGS_DRIVER_SUPPORTS_FAST_JBOD);
+			ddi_put32(acc, &initp->InitStructRevision,
+				AAC_INIT_STRUCT_REVISION_6);
+		} else if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) {
+			init_flags |= (AAC_INITFLAGS_NEW_COMM_TYPE2_SUPPORTED |
+				AAC_INITFLAGS_DRIVER_SUPPORTS_FAST_JBOD);
+			ddi_put32(acc, &initp->InitStructRevision,
+				AAC_INIT_STRUCT_REVISION_7);
+			ddi_put32(acc, &initp->MiniPortRevision, 0L);
+		} else { 
+			ddi_put32(acc, &initp->InitStructRevision,
+				AAC_INIT_STRUCT_REVISION_4);
+		}
+		if (softs->aac_support_opt2 & AAC_SUPPORTED_POWER_MANAGEMENT) {
+			init_flags |= AAC_INIT_FLAGS_DRIVER_SUPPORTS_PM;
+			init_flags |= AAC_INIT_FLAGS_DRIVER_USES_UTC_TIME;
+		}
 
-		ddi_put32(acc, &initp->InitStructRevision,
-		    AAC_INIT_STRUCT_REVISION_4);
 		ddi_put32(acc, &initp->InitFlags, init_flags);
 		/* Setup the preferred settings */
 		ddi_put32(acc, &initp->MaxIoCommands, softs->aac_max_fibs);
@@ -3704,6 +3491,9 @@
 		ddi_put32(acc, &initp->MaxIoSize,
 		    (softs->aac_max_sectors << 9));
 		ddi_put32(acc, &initp->MaxFibSize, softs->aac_max_fib_size);
+		ddi_put32(acc, &initp->MaxNumAif, softs->aac_max_aif);
+		ddi_put32(acc, &initp->HostRRQ_AddrLow, 
+			comm_space_phyaddr + offsetof(struct aac_comm_space,aac_host_rrq));
 	} else {
 		/*
 		 * Tells the adapter about the physical location of various
@@ -3721,8 +3511,6 @@
 		    offsetof(struct aac_comm_space, adapter_print_buf));
 		ddi_put32(acc, &initp->PrintfBufferSize,
 		    AAC_ADAPTER_PRINT_BUFSIZE);
-		ddi_put32(acc, &initp->MiniPortRevision,
-		    AAC_INIT_STRUCT_MINIPORT_REVISION);
 		ddi_put32(acc, &initp->HostPhysMemPages, AAC_MAX_PFN);
 
 		qoffset = (comm_space_phyaddr + \
@@ -3806,10 +3594,11 @@
 	(void) ddi_dma_sync(dma, 0, 0, DDI_DMA_SYNC_FORDEV);
 
 	/* Send init structure to the card */
+	softs->sync_slot_busy = 1;
 	if (aac_sync_mbcommand(softs, AAC_MONKER_INITSTRUCT,
 	    comm_space_phyaddr + \
 	    offsetof(struct aac_comm_space, init_data),
-	    0, 0, 0, NULL) == AACERR) {
+	    0, 0, 0, NULL, NULL) == AACERR) {
 		AACDB_PRINT(softs, CE_WARN,
 		    "Cannot send init structure to adapter");
 		return (AACERR);
@@ -3885,8 +3674,8 @@
 		switch (page) {
 		case 0x00:
 			/* Supported VPD pages */
-			if (vpdp == NULL ||
-			    bp->b_bcount < (AAC_VPD_PAGE_DATA + 3))
+			if (vpdp == NULL || 
+				bp->b_bcount < (AAC_VPD_PAGE_DATA + 3))
 				return;
 			bzero(vpdp, AAC_VPD_PAGE_LENGTH);
 			vpdp[AAC_VPD_PAGE_CODE] = 0x00;
@@ -3902,7 +3691,7 @@
 		case 0x80:
 			/* Unit serial number page */
 			if (vpdp == NULL ||
-			    bp->b_bcount < (AAC_VPD_PAGE_DATA + 8))
+				bp->b_bcount < (AAC_VPD_PAGE_DATA + 8))
 				return;
 			bzero(vpdp, AAC_VPD_PAGE_LENGTH);
 			vpdp[AAC_VPD_PAGE_CODE] = 0x80;
@@ -3917,7 +3706,7 @@
 		case 0x83:
 			/* Device identification page */
 			if (vpdp == NULL ||
-			    bp->b_bcount < (AAC_VPD_PAGE_DATA + 32))
+				bp->b_bcount < (AAC_VPD_ID_DATA + 32))
 				return;
 			bzero(vpdp, AAC_VPD_PAGE_LENGTH);
 			vpdp[AAC_VPD_PAGE_CODE] = 0x83;
@@ -3939,11 +3728,10 @@
 			sp = aac_vendor_id(softs, sp);
 			sp = aac_product_id(softs, sp);
 			sp = aac_lun_serialno(softs, tgt, sp);
-			idp[AAC_VPD_ID_LENGTH] = (uintptr_t)sp - \
-			    (uintptr_t)&idp[AAC_VPD_ID_DATA];
+			idp[AAC_VPD_ID_LENGTH] = sp - &idp[AAC_VPD_ID_DATA];
 
-			vpdp[AAC_VPD_PAGE_LENGTH] = (uintptr_t)sp - \
-			    (uintptr_t)&vpdp[AAC_VPD_PAGE_DATA];
+			vpdp[AAC_VPD_PAGE_LENGTH] =
+			    sp - &vpdp[AAC_VPD_PAGE_DATA];
 			pkt->pkt_state |= STATE_XFERRED_DATA;
 			break;
 
@@ -3990,18 +3778,26 @@
     union scsi_cdb *cdbp, struct buf *bp, int capacity)
 {
 	uchar_t pagecode;
+	struct mode_format *page3p;
+	struct mode_geometry *page4p;
 	struct mode_header *headerp;
-	struct mode_header_g1 *g1_headerp;
 	unsigned int ncyl;
-	caddr_t sense_data;
-	caddr_t next_page;
-	size_t sdata_size;
-	size_t pages_size;
-	int unsupport_page = 0;
+	union {
+		struct mode_header header;
+		struct {
+			uchar_t header[MODE_HEADER_LENGTH + MODE_BLK_DESC_LENGTH];
+			struct mode_format page;
+		} page3;
+		struct {
+			uchar_t header[MODE_HEADER_LENGTH + MODE_BLK_DESC_LENGTH];
+			struct mode_geometry page;
+		} page4;
+		struct {
+			uchar_t header[MODE_HEADER_LENGTH + MODE_BLK_DESC_LENGTH];
+			struct mode_control_scsi3 page;
+		} pageA;
+	} mode;
 
-	ASSERT(cdbp->scc_cmd == SCMD_MODE_SENSE ||
-	    cdbp->scc_cmd == SCMD_MODE_SENSE_G1);
-
 	if (!(bp && bp->b_un.b_addr && bp->b_bcount))
 		return;
 
@@ -4008,89 +3804,26 @@
 	if (bp->b_flags & (B_PHYS | B_PAGEIO))
 		bp_mapin(bp);
 	pkt->pkt_state |= STATE_XFERRED_DATA;
-	pagecode = cdbp->cdb_un.sg.scsi[0] & 0x3F;
+	bzero(&mode, sizeof(mode));
+	bzero(bp->b_un.b_addr, bp->b_bcount);
+	pagecode = cdbp->cdb_un.sg.scsi[0];
+	headerp = &mode.header;
 
-	/* calculate the size of needed buffer */
-	if (cdbp->scc_cmd == SCMD_MODE_SENSE)
-		sdata_size = MODE_HEADER_LENGTH;
-	else /* must be SCMD_MODE_SENSE_G1 */
-		sdata_size = MODE_HEADER_LENGTH_G1;
-
-	pages_size = 0;
 	switch (pagecode) {
+	/* SBC-3 7.1.3.3 Format device page */
 	case SD_MODE_SENSE_PAGE3_CODE:
-		pages_size += sizeof (struct mode_format);
-		break;
-
-	case SD_MODE_SENSE_PAGE4_CODE:
-		pages_size += sizeof (struct mode_geometry);
-		break;
-
-	case MODEPAGE_CTRL_MODE:
-		if (softs->flags & AAC_FLAGS_LBA_64BIT) {
-			pages_size += sizeof (struct mode_control_scsi3);
-		} else {
-			unsupport_page = 1;
-		}
-		break;
-
-	case MODEPAGE_ALLPAGES:
-		if (softs->flags & AAC_FLAGS_LBA_64BIT) {
-			pages_size += sizeof (struct mode_format) +
-			    sizeof (struct mode_geometry) +
-			    sizeof (struct mode_control_scsi3);
-		} else {
-			pages_size += sizeof (struct mode_format) +
-			    sizeof (struct mode_geometry);
-		}
-		break;
-
-	default:
-		/* unsupported pages */
-		unsupport_page = 1;
-	}
-
-	/* allocate buffer to fill the send data */
-	sdata_size += pages_size;
-	sense_data = kmem_zalloc(sdata_size, KM_SLEEP);
-
-	if (cdbp->scc_cmd == SCMD_MODE_SENSE) {
-		headerp = (struct mode_header *)sense_data;
-		headerp->length = MODE_HEADER_LENGTH + pages_size -
-		    sizeof (headerp->length);
-		headerp->bdesc_length = 0;
-		next_page = sense_data + sizeof (struct mode_header);
-	} else {
-		g1_headerp = (void *)sense_data;
-		g1_headerp->length = BE_16(MODE_HEADER_LENGTH_G1 + pages_size -
-		    sizeof (g1_headerp->length));
-		g1_headerp->bdesc_length = 0;
-		next_page = sense_data + sizeof (struct mode_header_g1);
-	}
-
-	if (unsupport_page)
-		goto finish;
-
-	if (pagecode == SD_MODE_SENSE_PAGE3_CODE ||
-	    pagecode == MODEPAGE_ALLPAGES) {
-		/* SBC-3 7.1.3.3 Format device page */
-		struct mode_format *page3p;
-
-		page3p = (void *)next_page;
+		headerp->bdesc_length = MODE_BLK_DESC_LENGTH;
+		page3p = &mode.page3.page;
 		page3p->mode_page.code = SD_MODE_SENSE_PAGE3_CODE;
 		page3p->mode_page.length = sizeof (struct mode_format);
 		page3p->data_bytes_sect = BE_16(AAC_SECTOR_SIZE);
 		page3p->sect_track = BE_16(AAC_SECTORS_PER_TRACK);
+		break;
 
-		next_page += sizeof (struct mode_format);
-	}
-
-	if (pagecode == SD_MODE_SENSE_PAGE4_CODE ||
-	    pagecode == MODEPAGE_ALLPAGES) {
-		/* SBC-3 7.1.3.8 Rigid disk device geometry page */
-		struct mode_geometry *page4p;
-
-		page4p = (void *)next_page;
+	/* SBC-3 7.1.3.8 Rigid disk device geometry page */
+	case SD_MODE_SENSE_PAGE4_CODE:
+		headerp->bdesc_length = MODE_BLK_DESC_LENGTH;
+		page4p = &mode.page4.page;
 		page4p->mode_page.code = SD_MODE_SENSE_PAGE4_CODE;
 		page4p->mode_page.length = sizeof (struct mode_geometry);
 		page4p->heads = AAC_NUMBER_OF_HEADS;
@@ -4099,27 +3832,57 @@
 		page4p->cyl_lb = ncyl & 0xff;
 		page4p->cyl_mb = (ncyl >> 8) & 0xff;
 		page4p->cyl_ub = (ncyl >> 16) & 0xff;
+		break;
 
-		next_page += sizeof (struct mode_geometry);
+	case MODEPAGE_CTRL_MODE: /* 64-bit LBA need large sense data */
+		if (softs->flags & AAC_FLAGS_LBA_64BIT) {
+			struct mode_control_scsi3 *mctl;
+
+			headerp->bdesc_length = MODE_BLK_DESC_LENGTH;
+			mctl = &mode.pageA.page;
+			mctl->mode_page.code = MODEPAGE_CTRL_MODE;
+			mctl->mode_page.length =
+			    sizeof (struct mode_control_scsi3) -
+			    sizeof (struct mode_page);
+			mctl->d_sense = 1;
+		}
+		break;
 	}
+	bcopy(&mode, bp->b_un.b_addr, 
+		(bp->b_bcount < sizeof(mode)) ? bp->b_bcount : sizeof(mode));
+}
 
-	if ((pagecode == MODEPAGE_CTRL_MODE || pagecode == MODEPAGE_ALLPAGES) &&
-	    softs->flags & AAC_FLAGS_LBA_64BIT) {
-		/* 64-bit LBA need large sense data */
-		struct mode_control_scsi3 *mctl;
+/*
+ * Start/Stop unit (Power Management)
+ */
+static void
+aac_startstop(struct aac_softstate *softs, union scsi_cdb *cdbp, uint32_t cid)
+{
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
+	struct aac_Container *cmd;
+	struct aac_Container_resp *resp;
+	uint32_t resp_status;
+	int rval;
 
-		mctl = (void *)next_page;
-		mctl->mode_page.code = MODEPAGE_CTRL_MODE;
-		mctl->mode_page.length =
-		    sizeof (struct mode_control_scsi3) -
-		    sizeof (struct mode_page);
-		mctl->d_sense = 1;
-	}
+	/* Get adapter config status */
+	cmd = (struct aac_Container *)&fibp->data[0];
 
-finish:
-	/* copyout the valid data. */
-	bcopy(sense_data, bp->b_un.b_addr, min(sdata_size, bp->b_bcount));
-	kmem_free(sense_data, sdata_size);
+	bzero(cmd, sizeof (*cmd) - CT_PACKET_SIZE);
+	ddi_put32(acc, &cmd->Command, VM_ContainerConfig);
+	ddi_put32(acc, &cmd->CTCommand.command, CT_PM_DRIVER_SUPPORT);
+	ddi_put32(acc, &cmd->CTCommand.param[0], cdbp->cdb_opaque[4] & 1 ?
+		AAC_PM_DRIVERSUP_START_UNIT : AAC_PM_DRIVERSUP_STOP_UNIT);
+	ddi_put32(acc, &cmd->CTCommand.param[1], cid); 
+	ddi_put32(acc, &cmd->CTCommand.param[2], cdbp->cdb_opaque[1] & 1);
+
+	rval = aac_sync_fib(softs, ContainerCommand,
+		AAC_FIB_SIZEOF(struct aac_Container));
+
+	resp = (struct aac_Container_resp *)cmd;
+	resp_status = ddi_get32(acc, &resp->Status);
+	if (rval != AACOK || resp_status != 0)
+		AACDB_PRINT(softs, CE_WARN, "Cannot start/stop a unit");
 }
 
 static int
@@ -4146,26 +3909,18 @@
     scsi_hba_tran_t *tran, struct scsi_device *sd)
 {
 	struct aac_softstate *softs = AAC_TRAN2SOFTS(tran);
-#if defined(DEBUG) || defined(__lock_lint)
+#if defined(AAC_DEBUG) || defined(__lock_lint)
 	int ctl = ddi_get_instance(softs->devinfo_p);
 #endif
-	uint16_t tgt = sd->sd_address.a_target;
-	uint8_t lun = sd->sd_address.a_lun;
+	int tgt = sd->sd_address.a_target;
+	int lun = sd->sd_address.a_lun;
 	struct aac_device *dvp;
 
 	DBCALLED(softs, 2);
 
 	if (ndi_dev_is_persistent_node(tgt_dip) == 0) {
-		/*
-		 * If no persistent node exist, we don't allow .conf node
-		 * to be created.
-		 */
-		if (aac_find_child(softs, tgt, lun) != NULL) {
-			if (ndi_merge_node(tgt_dip, aac_name_node) !=
-			    DDI_SUCCESS)
-				/* Create this .conf node */
-				return (DDI_SUCCESS);
-		}
+		(void) ndi_merge_node(tgt_dip, aac_name_node);
+		ddi_set_name_addr(tgt_dip, NULL);
 		return (DDI_FAILURE);
 	}
 
@@ -4174,7 +3929,7 @@
 	 * detected and valid
 	 */
 	mutex_enter(&softs->io_lock);
-	if (tgt >= AAC_MAX_DEV(softs)) {
+	if (tgt < 0 || tgt >= AAC_MAX_DEV(softs)) {
 		AACDB_PRINT_TRAN(softs,
 		    "aac_tran_tgt_init: c%dt%dL%d out", ctl, tgt, lun);
 		mutex_exit(&softs->io_lock);
@@ -4181,9 +3936,9 @@
 		return (DDI_FAILURE);
 	}
 
+	dvp = AAC_DEV(softs, tgt);
 	if (tgt < AAC_MAX_LD) {
-		dvp = (struct aac_device *)&softs->containers[tgt];
-		if (lun != 0 || !AAC_DEV_IS_VALID(dvp)) {
+		if (dvp == NULL || !(dvp->valid) || lun != 0) {
 			AACDB_PRINT_TRAN(softs, "aac_tran_tgt_init: c%dt%dL%d",
 			    ctl, tgt, lun);
 			mutex_exit(&softs->io_lock);
@@ -4197,27 +3952,8 @@
 		if (softs->containers[tgt].dev.dip == NULL &&
 		    strcmp(ddi_driver_name(sd->sd_dev), "sd") == 0)
 			softs->containers[tgt].dev.dip = tgt_dip;
-	} else {
-		dvp = (struct aac_device *)&softs->nondasds[AAC_PD(tgt)];
-		/*
-		 * Save the tgt_dip for the given target if one doesn't exist
-		 * already. Dip's for non-existance tgt's will be cleared in
-		 * tgt_free.
-		 */
-
-		if (softs->nondasds[AAC_PD(tgt)].dev.dip  == NULL &&
-		    strcmp(ddi_driver_name(sd->sd_dev), "sd") == 0)
-			softs->nondasds[AAC_PD(tgt)].dev.dip  = tgt_dip;
 	}
 
-	if (softs->flags & AAC_FLAGS_BRKUP) {
-		if (ndi_prop_update_int(DDI_DEV_T_NONE, tgt_dip,
-		    "buf_break", 1) != DDI_PROP_SUCCESS) {
-			cmn_err(CE_CONT, "unable to create "
-			    "property for t%dL%d (buf_break)", tgt, lun);
-		}
-	}
-
 	AACDB_PRINT(softs, CE_NOTE,
 	    "aac_tran_tgt_init: c%dt%dL%d ok (%s)", ctl, tgt, lun,
 	    (dvp->type == AAC_DEV_PD) ? "pd" : "ld");
@@ -4237,14 +3973,10 @@
 	int tgt = sd->sd_address.a_target;
 
 	mutex_enter(&softs->io_lock);
-	if (tgt < AAC_MAX_LD) {
-		if (softs->containers[tgt].dev.dip == tgt_dip)
-			softs->containers[tgt].dev.dip = NULL;
-	} else {
-		if (softs->nondasds[AAC_PD(tgt)].dev.dip == tgt_dip)
-			softs->nondasds[AAC_PD(tgt)].dev.dip = NULL;
-		softs->nondasds[AAC_PD(tgt)].dev.flags &= ~AAC_DFLAG_VALID;
-	}
+	if (tgt < AAC_MAX_LD)
+		softs->containers[tgt].dev.dip = NULL;
+	else
+		softs->nondasds[AAC_PD(tgt)].dev.valid = 0;
 	mutex_exit(&softs->io_lock);
 }
 
@@ -4260,16 +3992,16 @@
 {
 	int rval;
 
-	rval = PCI_MEM_GET32(softs, AAC_OMR0);
+	rval = AAC_FWSTATUS_GET(softs);
 
 	if (rval & AAC_KERNEL_UP_AND_RUNNING) {
 		rval = 0;
 	} else if (rval & AAC_KERNEL_PANIC) {
-		cmn_err(CE_WARN, "firmware panic");
 		rval = ((rval >> 16) & 0xff) + 1; /* avoid 0 as return value */
+		cmn_err(CE_WARN, "!Adapter firmware crashed with BLED %d", rval - 1);
 	} else {
-		cmn_err(CE_WARN, "firmware dead");
 		rval = -1;
+		cmn_err(CE_WARN, "!Adapter firmware dead");
 	}
 	return (rval);
 }
@@ -4281,26 +4013,26 @@
 	acp->flags |= AAC_CMD_ABORT;
 
 	if (acp->pkt) {
-		if (acp->slotp) { /* outstanding cmd */
-			acp->pkt->pkt_state |= STATE_GOT_STATUS;
-		}
+		/*
+		 * Each lun should generate a unit attention
+		 * condition when reset.
+		 * Phys. drives are treated as logical ones
+		 * during error recovery.
+		 */
+		if (softs->flags & AAC_STATE_RESET)
+			aac_set_arq_data_reset(softs, acp);
 
 		switch (reason) {
 		case CMD_TIMEOUT:
-			AACDB_PRINT(softs, CE_NOTE, "CMD_TIMEOUT: acp=0x%p",
-			    acp);
 			aac_set_pkt_reason(softs, acp, CMD_TIMEOUT,
 			    STAT_TIMEOUT | STAT_BUS_RESET);
 			break;
 		case CMD_RESET:
 			/* aac support only RESET_ALL */
-			AACDB_PRINT(softs, CE_NOTE, "CMD_RESET: acp=0x%p", acp);
 			aac_set_pkt_reason(softs, acp, CMD_RESET,
 			    STAT_BUS_RESET);
 			break;
 		case CMD_ABORTED:
-			AACDB_PRINT(softs, CE_NOTE, "CMD_ABORTED: acp=0x%p",
-			    acp);
 			aac_set_pkt_reason(softs, acp, CMD_ABORTED,
 			    STAT_ABORTED);
 			break;
@@ -4337,7 +4069,7 @@
 		struct aac_cmd *acp;
 
 		for (i = 0; i < AAC_MAX_LD; i++) {
-			if (AAC_DEV_IS_VALID(&softs->containers[i].dev))
+			if (softs->containers[i].dev.valid)
 				softs->containers[i].reset = 1;
 		}
 		while ((acp = softs->q_busy.q_head) != NULL)
@@ -4368,7 +4100,6 @@
 
 	mutex_enter(&softs->io_lock);
 	if (softs->ndrains) {
-		softs->drain_timeid = 0;
 		/*
 		 * If both ASYNC and SYNC bus throttle are held,
 		 * wake up threads only when both are drained out.
@@ -4393,7 +4124,6 @@
 aac_start_drain(struct aac_softstate *softs)
 {
 	if (softs->ndrains == 0) {
-		ASSERT(softs->drain_timeid == 0);
 		softs->drain_timeid = timeout(aac_check_drain, softs,
 		    AAC_QUIESCE_TICK * drv_usectohz(1000000));
 	}
@@ -4432,21 +4162,25 @@
 static int
 aac_reset_adapter(struct aac_softstate *softs)
 {
+	ddi_acc_handle_t acc = softs->comm_space_acc_handle;
 	int health;
-	uint32_t status;
-	int rval = AAC_IOP_RESET_FAILED;
+	uint32_t status, wait_count, reset_mask;
+	struct aac_fib *fibp;
+	struct aac_pause_command *pc;
+	int rval = AACERR;
 
 	DBCALLED(softs, 1);
-
 	ASSERT(softs->state & AAC_STATE_RESET);
 
-	ddi_fm_acc_err_clear(softs->pci_mem_handle, DDI_FME_VER0);
+	aac_fm_acc_err_clear(softs->pci_mem_handle[0], DDI_FME_VER0);
 	/* Disable interrupt */
-	AAC_DISABLE_INTR(softs);
+	AAC_SET_INTR(softs, 0);
 
 	health = aac_check_adapter_health(softs);
+	AACDB_PRINT(softs, CE_NOTE, 
+		"aac_reset_adapter() called, health %d", health);
 	if (health == -1) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
 		goto finish;
 	}
 	if (health == 0) /* flush drives if possible */
@@ -4453,45 +4187,41 @@
 		(void) aac_shutdown(softs);
 
 	/* Execute IOP reset */
-	if ((aac_sync_mbcommand(softs, AAC_IOP_RESET, 0, 0, 0, 0,
-	    &status)) != AACOK) {
-		ddi_acc_handle_t acc;
-		struct aac_fib *fibp;
-		struct aac_pause_command *pc;
+	if (softs->aac_support_opt2 & AAC_SUPPORTED_MU_RESET) {
+		/*
+		 * Sunrise Lake has dual cores and we must drag the
+		 * other core with us to reset simultaneously. There
+		 * are 2 bits in the Inbound Reset Control and Status
+		 * Register (offset 0x38) of the Sunrise Lake to reset
+		 * the chip without clearing out the PCI configuration
+		 * info (COMMAND & BARS).
+		 */
+		PCI_MEM_PUT32(softs, 0, AAC_IRCSR, AAC_IRCSR_CORES_RST);
 
-		if ((status & 0xf) == 0xf) {
-			uint32_t wait_count;
-
-			/*
-			 * Sunrise Lake has dual cores and we must drag the
-			 * other core with us to reset simultaneously. There
-			 * are 2 bits in the Inbound Reset Control and Status
-			 * Register (offset 0x38) of the Sunrise Lake to reset
-			 * the chip without clearing out the PCI configuration
-			 * info (COMMAND & BARS).
-			 */
-			PCI_MEM_PUT32(softs, AAC_IRCSR, AAC_IRCSR_CORES_RST);
-
-			/*
-			 * We need to wait for 5 seconds before accessing the MU
-			 * again 10000 * 100us = 1000,000us = 1000ms = 1s
-			 */
-			wait_count = 5 * 10000;
-			while (wait_count) {
-				drv_usecwait(100); /* delay 100 microseconds */
-				wait_count--;
-			}
-		} else {
-			if (status == SRB_STATUS_INVALID_REQUEST)
+		/*
+		 * We need to wait for 5 seconds before accessing the MU
+		 * again 10000 * 100us = 1000,000us = 1000ms = 1s
+		 */
+		wait_count = 5 * 10000;
+		while (wait_count) {
+			drv_usecwait(100); /* delay 100 microseconds */
+			wait_count--;
+		}
+	} else {
+		softs->sync_slot_busy = 1;
+		if ((aac_sync_mbcommand(softs, AAC_IOP_RESET_ALWAYS, 0, 0, 0, 0,
+			&status, &reset_mask)) != AACOK) {
+			if (status == SRB_STATUS_INVALID_REQUEST) {
 				cmn_err(CE_WARN, "!IOP_RESET not supported");
-			else /* probably timeout */
+				AACDB_PRINT(softs, CE_NOTE, 
+					"IOP_RESET not supported");
+			} else {		/* probably timeout */
 				cmn_err(CE_WARN, "!IOP_RESET failed");
-
+				AACDB_PRINT(softs, CE_NOTE, 
+					"IOP_RESET failed");
+			}
 			/* Unwind aac_shutdown() */
-			(void) aac_sync_fib_slot_bind(softs, &softs->sync_ac);
-			acc = softs->sync_ac.slotp->fib_acc_handle;
-
-			fibp = softs->sync_ac.slotp->fibp;
+			fibp = softs->sync_slot->fibp;
 			pc = (struct aac_pause_command *)&fibp->data[0];
 
 			bzero(pc, sizeof (*pc));
@@ -4502,20 +4232,28 @@
 			ddi_put32(acc, &pc->NoRescan, 1);
 
 			(void) aac_sync_fib(softs, ContainerCommand,
-			    AAC_FIB_SIZEOF(struct aac_pause_command));
-			aac_sync_fib_slot_release(softs, &softs->sync_ac);
+				AAC_FIB_SIZEOF(struct aac_pause_command));
 
-			if (aac_check_adapter_health(softs) != 0)
-				ddi_fm_service_impact(softs->devinfo_p,
-				    DDI_SERVICE_LOST);
-			else
-				/*
-				 * IOP reset not supported or IOP not reseted
-				 */
-				rval = AAC_IOP_RESET_ABNORMAL;
+			aac_fm_service_impact(softs->devinfo_p,
+				DDI_SERVICE_LOST);
+			if (health == 0)
+				rval = AACOK2;
 			goto finish;
+		} else if (softs->aac_support_opt2 & AAC_SUPPORTED_DOORBELL_RESET) {
+			PCI_MEM_PUT32(softs, 0, AAC_SRC_IDBR, reset_mask);
+			/*
+			 * We need to wait for 5 seconds before accessing the doorbell
+			 * again 10000 * 100us = 1000,000us = 1000ms = 1s
+			 */
+			wait_count = 5 * 10000;
+			while (wait_count) {
+				drv_usecwait(100); /* delay 100 microseconds */
+				wait_count--;
+			}
 		}
 	}
+	cmn_err(CE_NOTE, "!IOP_RESET finished successfully");
+	AACDB_PRINT(softs, CE_NOTE, "IOP_RESET finished successfully");
 
 	/*
 	 * Re-read and renegotiate the FIB parameters, as one of the actions
@@ -4525,10 +4263,10 @@
 	if (aac_common_attach(softs) != AACOK)
 		goto finish;
 
-	rval = AAC_IOP_RESET_SUCCEED;
+	rval = AACOK;
 
 finish:
-	AAC_ENABLE_INTR(softs);
+	AAC_SET_INTR(softs, 1);
 	return (rval);
 }
 
@@ -4567,7 +4305,7 @@
 static void
 aac_unhold_bus(struct aac_softstate *softs, int iocmds)
 {
-	int i, q, max_throttle;
+	int i, q;
 
 	for (q = 0; q < AAC_CMDQ_NUM; q++) {
 		if (iocmds & (1 << q)) {
@@ -4579,19 +4317,14 @@
 			if (q == AAC_CMDQ_ASYNC && ((softs->state &
 			    AAC_STATE_QUIESCED) || softs->ndrains))
 				continue;
-			if (q == AAC_CMDQ_ASYNC)
-				max_throttle = softs->total_slots -
-				    AAC_MGT_SLOT_NUM;
-			else
-				max_throttle = softs->total_slots - 1;
-			softs->bus_throttle[q] = max_throttle;
+			softs->bus_throttle[q] = softs->total_slots;
 			for (i = 0; i < AAC_MAX_LD; i++)
 				aac_set_throttle(softs,
 				    &softs->containers[i].dev,
-				    q, max_throttle);
+				    q, softs->total_slots);
 			for (i = 0; i < AAC_MAX_PD(softs); i++)
 				aac_set_throttle(softs, &softs->nondasds[i].dev,
-				    q, max_throttle);
+				    q, softs->total_slots);
 		}
 	}
 }
@@ -4599,24 +4332,20 @@
 static int
 aac_do_reset(struct aac_softstate *softs)
 {
-	int health;
-	int rval;
+	int health, rval;
+	int sync_cmds, async_cmds;
 
 	softs->state |= AAC_STATE_RESET;
 	health = aac_check_adapter_health(softs);
+	AACDB_PRINT(softs, CE_NOTE, "aac_do_reset() called, health %d", health);
 
 	/*
 	 * Hold off new io commands and wait all outstanding io
 	 * commands to complete.
 	 */
-	if (health == 0) {
-		int sync_cmds = softs->bus_ncmds[AAC_CMDQ_SYNC];
-		int async_cmds = softs->bus_ncmds[AAC_CMDQ_ASYNC];
-
-		if (sync_cmds == 0 && async_cmds == 0) {
-			rval = AAC_IOP_RESET_SUCCEED;
-			goto finish;
-		}
+	sync_cmds = softs->bus_ncmds[AAC_CMDQ_SYNC];
+	async_cmds = softs->bus_ncmds[AAC_CMDQ_ASYNC];
+	if (health == 0 && (sync_cmds || async_cmds)) {
 		/*
 		 * Give the adapter up to AAC_QUIESCE_TIMEOUT more seconds
 		 * to complete the outstanding io commands
@@ -4629,8 +4358,14 @@
 		 * Poll the adapter by ourselves in case interrupt is disabled
 		 * and to avoid releasing the io_lock.
 		 */
-		intr_handler = (softs->flags & AAC_FLAGS_NEW_COMM) ?
-		    aac_process_intr_new : aac_process_intr_old;
+		if ((softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) ||
+			(softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) ||
+			(softs->flags & AAC_FLAGS_NEW_COMM_TYPE34))
+			intr_handler = aac_process_intr_new_type1;
+		else if (softs->flags & AAC_FLAGS_NEW_COMM) 
+			intr_handler = aac_process_intr_new;
+		else
+			intr_handler = aac_process_intr_old;
 		while ((softs->bus_ncmds[AAC_CMDQ_SYNC] ||
 		    softs->bus_ncmds[AAC_CMDQ_ASYNC]) && timeout) {
 			drv_usecwait(100);
@@ -4638,28 +4373,21 @@
 			timeout--;
 		}
 		aac_unhold_bus(softs, AAC_IOCMD_SYNC | AAC_IOCMD_ASYNC);
-
-		if (softs->bus_ncmds[AAC_CMDQ_SYNC] == 0 &&
-		    softs->bus_ncmds[AAC_CMDQ_ASYNC] == 0) {
-			/* Cmds drained out */
-			rval = AAC_IOP_RESET_SUCCEED;
-			goto finish;
-		} else if (softs->bus_ncmds[AAC_CMDQ_SYNC] < sync_cmds ||
-		    softs->bus_ncmds[AAC_CMDQ_ASYNC] < async_cmds) {
-			/* Cmds not drained out, adapter overloaded */
-			rval = AAC_IOP_RESET_ABNORMAL;
-			goto finish;
-		}
 	}
 
 	/*
-	 * If a longer waiting time still can't drain any outstanding io
+	 * If a longer waiting time still can't drain all outstanding io
 	 * commands, do IOP reset.
 	 */
-	if ((rval = aac_reset_adapter(softs)) == AAC_IOP_RESET_FAILED)
-		softs->state |= AAC_STATE_DEAD;
+	if ((sync_cmds || async_cmds) &&
+		(softs->bus_ncmds[AAC_CMDQ_SYNC] == sync_cmds) &&
+		(softs->bus_ncmds[AAC_CMDQ_ASYNC] == async_cmds)) { 
+		if ((rval = aac_reset_adapter(softs)) == AACERR)
+			softs->state |= AAC_STATE_DEAD;
+	} else {
+		rval = AACOK2;
+	}
 
-finish:
 	softs->state &= ~AAC_STATE_RESET;
 	return (rval);
 }
@@ -4668,9 +4396,10 @@
 aac_tran_reset(struct scsi_address *ap, int level)
 {
 	struct aac_softstate *softs = AAC_TRAN2SOFTS(ap->a_hba_tran);
-	int rval;
+	int rval, rval2;
 
 	DBCALLED(softs, 1);
+	AACDB_PRINT(softs, CE_NOTE, "aac_tran_reset() called, level %d", level);
 
 	if (level != RESET_ALL) {
 		cmn_err(CE_NOTE, "!reset target/lun not supported");
@@ -4678,23 +4407,21 @@
 	}
 
 	mutex_enter(&softs->io_lock);
-	switch (rval = aac_do_reset(softs)) {
-	case AAC_IOP_RESET_SUCCEED:
-		aac_abort_iocmds(softs, AAC_IOCMD_OUTSTANDING | AAC_IOCMD_ASYNC,
-		    NULL, CMD_RESET);
+	rval2 = aac_do_reset(softs);
+	rval = (rval2 != AACERR) ? 1 : 0;
+	if (rval == 1 && !ddi_in_panic()) {
+		if (rval2 == AACOK)
+			aac_abort_iocmds(softs, AAC_IOCMD_OUTSTANDING | AAC_IOCMD_ASYNC,
+				NULL, CMD_RESET);
 		aac_start_waiting_io(softs);
-		break;
-	case AAC_IOP_RESET_FAILED:
-		/* Abort IOCTL cmds when adapter is dead */
+	} else {
+		/* Abort IOCTL cmds when system panic or adapter dead */
 		aac_abort_iocmds(softs, AAC_IOCMD_ALL, NULL, CMD_RESET);
-		break;
-	case AAC_IOP_RESET_ABNORMAL:
-		aac_start_waiting_io(softs);
 	}
 	mutex_exit(&softs->io_lock);
 
 	aac_drain_comp_q(softs);
-	return (rval == 0);
+	return (rval);
 }
 
 static int
@@ -4703,6 +4430,7 @@
 	struct aac_softstate *softs = AAC_TRAN2SOFTS(ap->a_hba_tran);
 
 	DBCALLED(softs, 1);
+	AACDB_PRINT(softs, CE_NOTE, "aac_tran_abort() called, pkt %p", pkt);
 
 	mutex_enter(&softs->io_lock);
 	aac_abort_iocmds(softs, 0, pkt, CMD_ABORTED);
@@ -4715,26 +4443,37 @@
 void
 aac_free_dmamap(struct aac_cmd *acp)
 {
+	uint_t i;
+	uint32_t offset;
+
 	/* Free dma mapping */
 	if (acp->flags & AAC_CMD_DMA_VALID) {
-		ASSERT(acp->buf_dma_handle);
-		(void) ddi_dma_unbind_handle(acp->buf_dma_handle);
+		ASSERT(acp->segments[0].buf_dma_handle);
+		for (i = 0; i < acp->segment_cnt; ++i) 
+			(void) ddi_dma_unbind_handle(acp->segments[i].buf_dma_handle);
 		acp->flags &= ~AAC_CMD_DMA_VALID;
 	}
 
-	if (acp->abp != NULL) { /* free non-aligned buf DMA */
-		ASSERT(acp->buf_dma_handle);
-		if ((acp->flags & AAC_CMD_BUF_WRITE) == 0 && acp->bp)
-			ddi_rep_get8(acp->abh, (uint8_t *)acp->bp->b_un.b_addr,
-			    (uint8_t *)acp->abp, acp->bp->b_bcount,
-			    DDI_DEV_AUTOINCR);
-		ddi_dma_mem_free(&acp->abh);
-		acp->abp = NULL;
+	if (acp->segments[0].abp != NULL) { /* free non-aligned buf DMA */
+		ASSERT(acp->segments[0].buf_dma_handle);
+		for (i = 0, offset = 0; i < acp->segment_cnt; ++i) {
+			if ((acp->flags & AAC_CMD_BUF_WRITE) == 0 && acp->bp)
+				ddi_rep_get8(acp->segments[i].abh, 
+					(uint8_t *)acp->bp->b_un.b_addr + offset,
+					(uint8_t *)acp->segments[i].abp, 
+					acp->segments[i].abp_size,
+					DDI_DEV_AUTOINCR);
+			offset += acp->segments[i].abp_size;
+			ddi_dma_mem_free(&acp->segments[i].abh);
+			acp->segments[i].abp = NULL;
+		}
 	}
 
-	if (acp->buf_dma_handle) {
-		ddi_dma_free_handle(&acp->buf_dma_handle);
-		acp->buf_dma_handle = NULL;
+	for (i = 0; i < acp->segment_cnt; ++i) {
+		if (acp->segments[i].buf_dma_handle) {
+			ddi_dma_free_handle(&acp->segments[i].buf_dma_handle);
+			acp->segments[i].buf_dma_handle = NULL;
+		}
 	}
 }
 
@@ -4742,7 +4481,7 @@
 aac_unknown_scmd(struct aac_softstate *softs, struct aac_cmd *acp)
 {
 	AACDB_PRINT(softs, CE_CONT, "SCMD 0x%x not supported",
-	    ((union scsi_cdb *)(void *)acp->pkt->pkt_cdbp)->scc_cmd);
+	    ((union scsi_cdb *)acp->pkt->pkt_cdbp)->scc_cmd);
 	aac_free_dmamap(acp);
 	aac_set_arq_data(acp->pkt, KEY_ILLEGAL_REQUEST, 0x20, 0x00, 0);
 	aac_soft_callback(softs, acp);
@@ -4762,7 +4501,7 @@
 
 	dvp = (struct aac_container *)acp->dvp;
 	pkt = acp->pkt;
-	cdbp = (void *)pkt->pkt_cdbp;
+	cdbp = (union scsi_cdb *)pkt->pkt_cdbp;
 	bp = acp->bp;
 
 	switch (cdbp->scc_cmd) {
